-- Ripped from ErrorMonster, thanks Rabbit
local	errorList = {}
do
	local list = {
		SPELL_FAILED_NO_COMBO_POINTS,   -- That ability requires combo points
		SPELL_FAILED_TARGETS_DEAD,      -- Your target is dead
		SPELL_FAILED_SPELL_IN_PROGRESS, -- Another action is in progress
		SPELL_FAILED_TARGET_AURASTATE,  -- You can't do that yet. (TargetAura)
		SPELL_FAILED_CASTER_AURASTATE,  -- You can't do that yet. (CasterAura)
		SPELL_FAILED_NO_ENDURANCE,      -- Not enough endurance
		SPELL_FAILED_BAD_TARGETS,       -- Invalid target
		SPELL_FAILED_NOT_MOUNTED,       -- You are mounted
		SPELL_FAILED_NOT_ON_TAXI,       -- You are in flight
		SPELL_FAILED_NOT_INFRONT,       -- You must be in front of your target
		SPELL_FAILED_NOT_IN_CONTROL,    -- You are not in control of your actions
		SPELL_FAILED_MOVING,            -- Can't do that while moving
		SPELL_FAILED_INTERRUPTED, 
		SPELL_FAILED_INTERRUPTED_COMBAT,
		SPELL_FAILED_UNIT_NOT_INFRONT,
		SPELL_FAILED_SPELL_UNAVAILABLE,
		SPELL_FAILED_STUNNED,
		ERR_USE_BAD_ANGLE,
		ERR_GENERIC_NO_TARGET,          -- You have no target.
		ERR_ABILITY_COOLDOWN,           -- Ability is not ready yet.
		ERR_OUT_OF_ENERGY,              -- Not enough energy
		ERR_NO_ATTACK_TARGET,           -- There is nothing to attack.
		ERR_SPELL_COOLDOWN,             -- Spell is not ready yet. (Spell)
		ERR_OUT_OF_RAGE,                -- Not enough rage.
		ERR_INVALID_ATTACK_TARGET,      -- You cannot attack that target.
		ERR_OUT_OF_MANA,                -- Not enough mana
		ERR_NOEMOTEWHILERUNNING,        -- You can't do that while moving!
		OUT_OF_ENERGY,                  -- Not enough energy.
	}
	for i, message in pairs(list) do
		errorList[message] = true
	end
end

local active = false
local frame = CreateFrame("Frame")
local save_Sound_EnableErrorSpeech

local function Activate()
	if not active then
		frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		save_Sound_EnableErrorSpeech = GetCVar("Sound_EnableErrorSpeech")
		SetCVar("Sound_EnableErrorSpeech", 0)	
		active = true
	end
end

local function Disactivate()
	if active then
		frame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		SetCVar("Sound_EnableErrorSpeech", save_Sound_EnableErrorSpeech)
		active = false
	end
end

frame:SetScript('OnEvent', function(self, event, unit, spell)
	if unit == "player" then 
		return Disactivate()
	end
end)

local orig_UIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent
function UIErrorsFrame_OnEvent(self, event, message, ...)
	if active and (event == "SYSMSG" or event == "UI_INFO_MESSAGE" or event == "UI_ERROR_MESSAGE") and errorList[message] then
		return Disactivate()
	end
	return orig_UIErrorsFrame_OnEvent(self, event, message, ...)
end

SLASH_QUIETCAST1 = "/quietcast"
SLASH_QUIETCAST2 = "/quiet"
SLASH_QUIETCAST1 = "/qc"
SlashCmdList.QUIETCAST = Activate
